/* This is free software. See COPYING for details. */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include "diag.h"
#include "debug.h"
#include "hmc5883l.h"
#include "calibrate.h"
#include "heading.h"

int main(void) {
   hmc5883l_state_t state;
   calibration_t calib;

   diag("Initializing... please hold still.");

   /* Set up the sensor: */
   state.cfg.avg = AVG_8;
   //state.cfg.gain = GAIN_1370;
   state.cfg.bias = BIAS_NONE;
   state.cfg.gain = GAIN_1090;
   if((state.fd = hmc5883l_open()) < 0) return -1;
   if(hmc5883l_config(&state)) return -1;

   /* Get calibration data: */
   if(calibrate(&state, &calib)) return -1;

   diag("Ready to read...");

   while(1) {
      if(hmc5883l_read(&state)) return -1;
      heading(&(state.pos), &calib);
      //diag("HDG: %f", 180.0*heading(&(state.pos), &calib)/M_PI);
   }

   if(close(state.fd)) return sysdiag("close", "can't close I2C bus");
   return 0;
}
